# 56. Wgraj zdjęcia

Wysyłanie zdjęcia przez S3 składa się z 2 kroków:

1. **Poproś o link z wcześniejszym podpisem (pre-signed) do bezpośredniego przesłania.**&#x20;

Jako dane wejściowe:&#x20;

* fileExtention - jpeg LUB jpg LUB png,&#x20;
* farmUuid - uuid gospodarstwa,
* fieldUuid - uuid pola,
* noteUuid - uuid notatki dla bezpośredniego linku do przesłanego zdjęcia,
* commentUuid - uuid komentarza dla bezpośredniego linku do przesłanego zdjęcia (opcjonalne).&#x20;

Jako dane wyjściowe:

* uuid - oczekiwany uuid po przesłaniu i przetworzeniu,
* farmUuid - taki sam jak wejściowy,
* fieldUuid - taki sam jak wejściowy,
* noteUuid - taki sam jak wejściowy,
* commentUuid - taki sam jak wejściowy (jeśli istniał),
* s3Url - URL używany do przesłania zdjęcia,
* s3Fields - atrybuty do przekazania w formularzu przesyłania zdjęcia.

Szczegóły użycia s3Url i s3Fields opisano w drugim kroku.&#x20;

Atrybuty są ważne tylko przez 60 minut na przesłanie zdjęcia.

{% code overflow="wrap" lineNumbers="true" %}

```graphql
mutation generatePresignedPostPhotoData {
  generatePresignedPostPhotoData(input:{
    farmUuid: "89196056-61e5-4bce-b676-d488d611a829" 
    fieldUuid: "586a2ef2-03e4-4715-846c-07a2f0cb3016"
    noteUuid: "4a94da1c-f655-4f17-961a-4b0323e5129c"
    fileExtention: jpeg
    
  } ) {
    uuid
    noteUuid
    fieldUuid
    farmUuid
    s3Url
    s3Fields
  }
}
```

{% endcode %}

2. **Wyślij lokalne zdjęcie na s3Url z predefiniowanymi atrybutami formularza z s3Fields.**

{% code overflow="wrap" lineNumbers="true" %}

```bash
curl --location --request POST '<s3Url>' \
--form 'key="<value_in_s3Fields>"' \
--form 'AWSAccessKeyId="<value_in_s3Fields>"' \
--form 'x-amz-security-token="<value_in_s3Fields>"' \
--form 'policy="<value_in_s3Fields>"' \
--form 'signature="<value_in_s3Fields>"' \
--form 'file=@"<local_file_path>"'
```

{% endcode %}

Powiadomienia o przetwarzaniu będą dostarczane za pomocą mechanizmu subskrypcji opisanego w GraphQL -> Samples -> [1. Subskrypcja: Pobierz zdarzenia](/geopard-tutorials/pl/dokumentacja-api/przeglad-zapytan-api-geopard/1.-subskrypcja-pobierz-zdarzenia.md).

{% hint style="info" %}
Użyj ‘Accept-Encoding’:’gzip, deflate, br’.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.geopard.tech/geopard-tutorials/pl/dokumentacja-api/przeglad-zapytan-api-geopard/56.-wgraj-zdjecia.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
